variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task

stages:
  - Analysis
  - Test
  - SonarCloud

pylint:
  stage: Analysis
  image: "python:3.9"
  before_script:
    - python --version
    - pip install pipenv
    - pipenv install --dev
  script:
    - pipenv run pylint -d R0401 main/ models/ tests/ controllers/

pytest:
  stage: Test
  image: "python:3.9"
  before_script:
    - python --version
    - pip install pipenv
    - pipenv install --dev
  script:
    - pipenv run coverage erase
    - pipenv run coverage run --branch --source controllers,models,main --omit=tests/ -m pytest -v --junitxml=pytest-report.xml
    - pipenv run coverage xml -i
  artifacts:
    when: always
    reports:
      junit: pytest-report.xml
      cobertura: coverage.xml
    paths:
      - coverage.xml


sonarcloud-check:
  stage: SonarCloud
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - sonar-scanner
  needs:
    - job: pytest
      artifacts: true
#  only:
#    - merge_requests
#    - main
#    - develop
